#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "_new_value4xi.py">
#<abstract4xi abstract = "providing function _new_value4xi"/> 
#<refer4xi reference = "sharedctypes.py"/> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['_new_value4xi'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi   

import ctypes
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
try:                             # Python ones
    from multiprocessing.sharedctypes import _new_value 
except:
    print("_new_value4xi.py: *** failed in from multiprocessing.sharedctypes import _new_value ***")     
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from bufferwrapper4xi import BufferWrapper4Xi
from examine4xi import examine4xi
from rebuild_ctype4xi import rebuild_ctype4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "new-value4xi" usage = "
#  sharedxctypes.py
#      RawValue:
#          obj = _new_value(type_)
#
#  copy4xi.py:
#      new_obj4xi = _new_value4xi(type(obj))
#  rawarray4xi.py:
#      result2xi = _new_value4xi(type2xi)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def _new_value4xi(type_): 
    '''
    returns new value 
    '''
    
    # -----------------------------------------------------------------------------------------    
    # (Step 1/4) 
    # -----------------------------------------------------------------------------------------       
    class2print = "_new_value4xi"
    method2print = "_new_value4xi" 
    
    message2print = "{(Step 1/4a) started" + "; new-value4xi-started: " + str(_new_value4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # <function _new_value4xi at 0x00000000031A9EA0>
    
    message2print = "{(Step 1/4b) passed" + "; type-passed-to-new-value4xi: " + str(type_) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # <class 'rawarray4xi.c_char_Array_12'>
    # <class 'ctypes.c_long'>
    # <class 'rawarray4xi.Point4Xi_Array_3'>
    
    if examine4xi(class2print, method2print): 
        message2print = "{performing" + "; _new_value-performing-by-_new_value4xi: " + str(_new_value) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                
        
        return _new_value(type_)
                         
    else:    
         
        # -----------------------------------------------------------------------------------------    
        # (Step 2/4) 
        # -----------------------------------------------------------------------------------------        
        ack2size = False
        try:
            message2print = "{(Step 2/4a) passing" + "; type-passing-to-ctypes-sizeof-by-new-value4xi: " + str(type_) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
            # <class 'rawarray4xi.c_char_Array_12'>
            # <class 'ctypes.c_long'>
            # <class 'rawarray4xi.Point4Xi_Array_3'>
             
            size2xi = ctypes.sizeof(type_)
        
            message2print = "{(Step 2/4b) set" + "; size2xi-set-by-new-value4xi to: " + str(size2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 12, 4, 72
            
            ack2size = True
            
        except:
    
            message2print = "{yielded" + "; ack2size-yielded-by-new-value4xi: " + str(ack2size)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
                     
        
        # -----------------------------------------------------------------------------------------    
        # (Step 3/4)
        # -----------------------------------------------------------------------------------------        
        ack2wrapper = False
        if ack2size is True:
            try:
                message2print = "{(Step 3/4a) passing" + "; size2xi-passing-to-BufferWrapper4Xi-by-new-value4xi: " + str(size2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
                # 12, 4, 72        
    
                wrapper2xi = BufferWrapper4Xi(size2xi)
        
                message2print = "{(Step 3/4b) got" + "; wrapper2xi-got-by-new-value4xi: " + str(wrapper2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # <bufferwrapper4xi.BufferWrapper4Xi object at 0x0000000003AA4C18>
                # <bufferwrapper4xi.BufferWrapper4Xi object at 0x0000000003A84EF0>
                # <bufferwrapper4xi.BufferWrapper4Xi object at 0x000000000396EA90>
                ack2wrapper = True   
            
            except:
                message2print = "{(Step 3/4c) yielded" + "; ack2wrapper-yielded-by-new-value4xi: " + str(ack2wrapper)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
        else:
            message2print = "{(Step 3/4d) yielded" + "; ack2size-yielded-by-new-value4xi: " + str(ack2size)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)         
                        
            
        # -----------------------------------------------------------------------------------------    
        # (Step 4/4)
        # -----------------------------------------------------------------------------------------        
        if ack2wrapper is False:
        
            message2print = "{(Step 4/4a) hit" + "; ack2wrapper-hit-by-new-value4xi: " + " *** " + str(ack2wrapper)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                
            return None
            
        else:
            message2print = "{(Step 4/4b1) passing" + "; type-passing-to-rebuild-ctype4xi-by-new-value4xi: " + str(type_) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
            # <class 'rawarray4xi.c_char_Array_12'>
            # <class 'ctypes.c_long'>
            # <class 'rawarray4xi.Point4Xi_Array_3'>
            
            message2print = "{(Step 4/4b2) passing" + "; wrapper2xi-passing-to-rebuild-ctype4xi-by-new-value4xi: " + str(wrapper2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # <bufferwrapper4xi.BufferWrapper4Xi object at 0x0000000003AA4C18>
            # <bufferwrapper4xi.BufferWrapper4Xi object at 0x0000000003A84EF0>
            # <bufferwrapper4xi.BufferWrapper4Xi object at 0x000000000396EA90>
                    
            message2print = "{(Step 4/4b3) returning" + "; rebuild-ctype4xi-function-returning-by-new-value4xi: " + str(rebuild_ctype4xi) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            # <function rebuild_ctype4xi at 0x0000000003738598>
                    
            return rebuild_ctype4xi(type_, wrapper2xi, None)
    
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_new_value4xi.txt
#   sense-test-new-value4xi.xml
#   reason-test-new-value4xi.xml
#   ace-test-new-value4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of _new_value4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

